package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.OrderRefundAddressService;
import com.gxwebsoft.shop.entity.OrderRefundAddress;
import com.gxwebsoft.shop.param.OrderRefundAddressParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 售后单退货地址记录表控制器
 *
 * @author 科技小王子
 * @since 2023-05-18 13:09:51
 */
@Api(tags = "售后单退货地址记录表管理")
@RestController
@RequestMapping("/api/shop/order-refund-address")
public class OrderRefundAddressController extends BaseController {
    @Resource
    private OrderRefundAddressService orderRefundAddressService;

    @PreAuthorize("hasAuthority('shop:orderRefundAddress:list')")
    @OperationLog
    @ApiOperation("分页查询售后单退货地址记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<OrderRefundAddress>> page(OrderRefundAddressParam param) {
        PageParam<OrderRefundAddress, OrderRefundAddressParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(orderRefundAddressService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(orderRefundAddressService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:orderRefundAddress:list')")
    @OperationLog
    @ApiOperation("查询全部售后单退货地址记录表")
    @GetMapping()
    public ApiResult<List<OrderRefundAddress>> list(OrderRefundAddressParam param) {
        PageParam<OrderRefundAddress, OrderRefundAddressParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(orderRefundAddressService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(orderRefundAddressService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:orderRefundAddress:list')")
    @OperationLog
    @ApiOperation("根据id查询售后单退货地址记录表")
    @GetMapping("/{id}")
    public ApiResult<OrderRefundAddress> get(@PathVariable("id") Integer id) {
        return success(orderRefundAddressService.getById(id));
        // 使用关联查询
        //return success(orderRefundAddressService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:orderRefundAddress:save')")
    @OperationLog
    @ApiOperation("添加售后单退货地址记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody OrderRefundAddress orderRefundAddress) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          orderRefundAddress.setUserId(loginUser.getUserId());
        }
        if (orderRefundAddressService.save(orderRefundAddress)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:orderRefundAddress:update')")
    @OperationLog
    @ApiOperation("修改售后单退货地址记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody OrderRefundAddress orderRefundAddress) {
        if (orderRefundAddressService.updateById(orderRefundAddress)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:orderRefundAddress:remove')")
    @OperationLog
    @ApiOperation("删除售后单退货地址记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (orderRefundAddressService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:orderRefundAddress:save')")
    @OperationLog
    @ApiOperation("批量添加售后单退货地址记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<OrderRefundAddress> list) {
        if (orderRefundAddressService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:orderRefundAddress:update')")
    @OperationLog
    @ApiOperation("批量修改售后单退货地址记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<OrderRefundAddress> batchParam) {
        if (batchParam.update(orderRefundAddressService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:orderRefundAddress:remove')")
    @OperationLog
    @ApiOperation("批量删除售后单退货地址记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (orderRefundAddressService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
